<template>
  <el-row :gutter="20">
    <!-- 左侧部门树 -->
    <el-col :span="4" :xs="24">
      <ContentWrap class="h-1/1">
        <IotOrgTree @node-click="handleDeptNodeClick"/>
      </ContentWrap>
    </el-col>
    <el-col :span="20" :xs="24">
      <ContentWrap>
        <!-- 搜索工作栏 -->
        <el-form
          class="-mb-15px"
          :model="queryParams"
          ref="queryFormRef"
          :inline="true"
          label-width="68px"
        >
          <el-form-item label="网关" prop="gatewayCode">
            <el-input
              v-model="queryParams.gatewayCode"
              placeholder="请输入网关"
              clearable
              @keyup.enter="handleQuery"
              class="!w-240px"
            />
          </el-form-item>

          <el-form-item label="机台" prop="machineName">
            <el-input
              v-model="queryParams.machineName"
              placeholder="请输入机台"
              clearable
              @keyup.enter="handleQuery"
              class="!w-240px"
            />
          </el-form-item>

          <el-form-item label="设备" prop="deviceCode">
            <el-input
              v-model="queryParams.deviceCode"
              placeholder="请输入设备编码"
              clearable
              @keyup.enter="handleQuery"
              class="!w-240px"
            />
          </el-form-item>
          <el-form-item label="采集时间" prop="deviceDataTime">
            <el-date-picker
              @change="handleQuery"
              v-model="queryParams.deviceDataTime"
              value-format="YYYY-MM-DD HH:mm:ss"
              type="daterange"
              start-placeholder="开始日期"
              end-placeholder="结束日期"
              :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"
              class="!w-240px"
            />
          </el-form-item>

          <el-form-item>
            <el-button @click="handleQuery">
              <Icon icon="ep:search" class="mr-5px"/>
              搜索
            </el-button>
            <el-button @click="resetQuery">
              <Icon icon="ep:refresh" class="mr-5px"/>
              重置
            </el-button>
            <el-button
              type="success"
              plain
              @click="handleExport"
              :loading="exportLoading"
              v-hasPermi="['iot:mqtt-record:export']"
            >
              <Icon icon="ep:download" class="mr-5px"/>
              导出
            </el-button>
          </el-form-item>
        </el-form>
      </ContentWrap>

      <!-- 列表 -->
      <ContentWrap>
        <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
          <el-table-column label="设备编码" align="left" prop="deviceCode"  width="180px"/>
          <el-table-column label="设备名称" align="left" prop="deviceName"  width="180px"/>
          <el-table-column label="设备采集时间" align="center" prop="deviceDataTime" :formatter="dateFormatter" width="180px"/>
          <el-table-column label="系统接收时间" align="center" prop="createTime" :formatter="dateFormatter" width="180px"/>
          <el-table-column label="数据" align="center" prop="deviceData"/>
          <el-table-column label="网关" align="center" prop="gatewayCode"/>
          <el-table-column label="机台" align="center" prop="machineName"/>
          <el-table-column label="用户" align="center" prop="workerName"/>
          <el-table-column label="操作" align="center" fixed="right" width="150">
            <template #default="scope">
              <el-button
                link
                type="primary"
                @click="copyTextToClipboard(scope.row.deviceData)"
                v-hasPermi="['iot:kanban:update']"
              >
                复制数据
              </el-button>
            </template>
          </el-table-column>
        </el-table>
        <!-- 分页 -->
        <Pagination
          :total="total"
          v-model:page="queryParams.pageNo"
          v-model:limit="queryParams.pageSize"
          @pagination="getList"
        />
      </ContentWrap>
    </el-col>
  </el-row>
  <!-- 表单弹窗：添加/修改 -->
  <MqttRecordForm ref="formRef" @success="getList"/>
</template>

<script setup lang="ts">
import {dateFormatter} from '@/utils/formatTime'
import download from '@/utils/download'
import {MqttRecordApi, MqttRecordVO} from '@/api/iot/mqttrecord'
import MqttRecordForm from './MqttRecordForm.vue'
import {defaultProps} from "@/utils/tree";
import DeptTree from "@/views/system/user/DeptTree.vue";

/** 数采记录 列表 */
defineOptions({name: 'MqttRecord'})

const message = useMessage() // 消息弹窗
const {t} = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const list = ref<MqttRecordVO[]>([]) // 列表的数据
const total = ref(0) // 列表的总页数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  machineId: undefined,
  deviceDataTime: [],
  deviceData: undefined,
  deviceCode: undefined,
  deviceId: undefined,
  workerName: undefined,
  gatewayCode: undefined,
  createTime: [],
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await MqttRecordApi.getMqttRecordPage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await MqttRecordApi.deleteMqttRecord(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {
  }
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await MqttRecordApi.exportMqttRecord(queryParams)
    download.excel(data, '数采记录.xls')
  } catch {
  } finally {
    exportLoading.value = false
  }
}

/** 初始化 **/
onMounted(() => {
  getList()
})

/** 处理部门被点击 */
const handleDeptNodeClick = async (row) => {
  queryParams.machineId = row.id
  await getList()
}

//复制数据
function copyTextToClipboard(text: string): Promise<void> {
  return navigator.clipboard.writeText(text)
    .then(() => {
      message.success('Text copied to clipboard')
    })
    .catch((error) => {
      message.success('Could not copy text: '+ error);
    });
}
</script>
